User Interface - Bug #4557

radio-set deviations from the 4GL GUI
02/27/2020 08:36 AM - Greg Shah
#1 - 02/27/2020 08:41 AM - Greg Shah

Eugenie found this list of bugs (testing with branch 4335a) while running the radio-set testcases (in testcases/uast/):

1. Widget is not highlighted(color must be changed) on mouse hover in Windows8 theme(all tests)

2. The widget size(width and height) is calculated incorrectly when size is not explicitly specified(1-3 pixels difference)(All tests with implicit size.

rs_test0*.p for example).

3. Tooltip behavior is different. Tooltip position changing in 4gl when moving from one button to another, like the tooltip owner is the button, not

radio-set, the text is the same. In FWD the tooltip acts as belonging to the whole radio-set(rs_test5.p).

4. FORM statement does not enable radio-set which is initially disabled, screen value is different(rs_test7.p).

5. ENTRY event handling deviation(rs_test8.p).
6. MODIFIED handling is different, initial value is different for MODIFIED attribute(rs_test8.p, rs_test9.p).

7.In 4GL the accelerator key char is not underlined with & prefix, while in FWD it is underlined(test-radio-set-1.p).

#3 - 11/18/2021 09:51 AM - Roger Borrello

Test uast/radio_set/rs_test7 1.p

This test:

message "Hit a key to start".
pause.

def var ch as char view-as radio-set radio-buttons "a", "1", "b", "2".

def var num as int init 2 view-as combo-box list-item-pairs "One", 1, "Two", 2,
def var flag as char init "true" view-as selection-list list-item-pairs "Happy",
ocadile" size 25 by 5.

def var txt as char init "".

form ch num flag txt with frame fl side-labels.

/* 21 2 */
message ch:screen-value num:screen-value flag:screen-value.

ch:radio-buttons = "c,3,d,4".
num:list-item-pairs = "One,1l,Two, 2, Three, 3".
flag:list-item-pairs = "On, true,Off, false,Oui,yes,Non,no".
/* 3 2 2 %/
message ch:screen-value num:screen-value flag:screen-value.

/* realize everything */
enable all with frame fl.

ch:radio-buttons = "e,5,f,6".

num:list-item-pairs = "OneOne,1ll, TwoTwo, 22, ThreeThree, 33".
flag:list-item-pairs = "Off, false,On, true,Non,no,Oui,yes".
/* 31 2 */

message ch:screen-value num:screen-value flag:screen-value.

Results in:

1 ?

3 2

5} 2

Instead of:
?

3 ?

5 2

#4 - 11/18/2021 10:04 AM - Roger Borrello
- File 4557 test-rs_4 5.png added

T /radi I 4

This test results in formatting issues, which may, or may not, be related to radio sets specifically. There is also a note in #5034-1449 regarding this.
Enter data or press ESC to end.

420 . /uast/radio_set/rs_test2 1.
471 . /uast/radio_set/rs_test2 2.
432 . /uast/radio_set/rs_test2 3.
423 . /uast/radlo_set/rs_test2 4.
424 . /uast/radlo_set/rs_test2 5.
425 . /uast/radio_set/rs_test3.p
426 . /uast/radic_set/rs_testd.p
427 . /uast/radio_set/rs_testd 1.p
#5 - 11/18/2021 10:22 AM - Roger Borrello
Test uast/radio_set/rs_test8.p

This test:

message "Hit a key to start".
pause.

/** Define widgets **/
define variable Rs as character initial "One"
view—-as radio-set radio-buttons "One", "1", "Two", "2"
/* define variable Stat as logical. */
define variable RsValue as character.

define button ExitButton label "Exit".
/* Define frames */

define frame fO0
Rs ExitButton

with side-labels size-chars 60 by 15 centered title "Modified attribute radio-set,

/* Trigger definitions */

on value-changed of Rs
do:
RsValue = Rs:screen-value.
message "The value changed to: " RsValue.
end.

on entry of Rs

do:
message "ENTRY event received, RADIO-SET:MODIFIED is:
end.
message "RADIO-SET:MODIFIED is: " Rs:modified.

enable all with frame £O.

message "RADIO-SET:MODIFIED is: " Rs:modified.

wait-for choose of ExitButton.

Results in:

RADIO-SET:MODIFIED is: yes
ENTRY event received, RADIO-SET:MODIFIED is: yes

Instead of:

RADIO-SET:MODIFIED is: no
ENTRY event received, RADIO-SET:MODIFIED is: no
#6 - 11/18/2021 10:23 AM - Roger Borrello
Results from #4557-3, #4557-4, and #4557-5 were found using 3821c_13187

Files

4557 test-rs_4_5.png 58.8 KB 11/18/2021 Roger Borrello
